package org.eclipse.palamedes.kif.core.ast;


public class KIFComment extends KIFSent {

    private String comment;

    KIFComment(AST ast) {
        super(ast);
    }

    @Override
    ASTNode clone0(AST ast) {
        KIFComment newNode = ast.newComment(comment);
        newNode.setSourceStart ( getSourceStart()  );
        newNode.setSourceLength( getSourceLength() );
        return newNode;
    }

    @Override
    int getNodeType0() {
        return ASTNode.COMMENT;
    }

    @Override
    boolean subtreeMatch0(ASTMatcher matcher, Object other) {
        return false;
    }

    @Override
    public void traverse(ASTVisitor visitor) {
    }

    public String getComment() {
        return comment;
    }

    public void setComment(String comment) {
        this.comment = comment;
    }

    protected final void copyMembers(KIFComment node) {
        super.copyMembers(node);
        comment = node.comment;
    }

    @Override
    public String getName() {
        return null;
    }

    @Override
    public int getOperandCount() {
        return 0;
    }

    @Override
    public KIFSeq<? extends ASTNode> getOperands() {
        return null;
    }

    @Override
    public String toString() {
        return comment;
    }

}
