package org.eclipse.palamedes.kif.core.ast;

public class KIFIndVar extends KIFTerm {

    private String varName;

    KIFIndVar(AST ast) {
        super(ast);
    }

    @Override
    public String getName() {
        return varName;
    }

    public void setVarName(String varName) {
        this.varName = varName;
    }

    @Override
    ASTNode clone0(AST ast) {
        KIFIndVar newNode = ast.newIndVar(varName);
        newNode.setSourceStart ( getSourceStart()  );
        newNode.setSourceLength( getSourceLength() );
        return newNode;
    }

    @Override
    final int getNodeType0() {
        return ASTNode.INDVAR;
    }

    @Override
    public void traverse(ASTVisitor visitor) {
        visitor.visit(this);
    }

    @Override
    boolean subtreeMatch0(ASTMatcher matcher, Object other) {
        return matcher.match(this, other);
    }

    @Override
    public String toString() {
        return varName;
    }

    protected final void copyMembers(KIFIndVar node) {
        super.copyMembers(node);
        varName = node.varName;
    }

	@Override
	public KIFSeq<KIFTerm> getTerms() {
		return new KIFSeq<KIFTerm>();
	}
}
