package org.eclipse.palamedes.kif.core.ast;

public class KIFOperator extends ASTNode {

    private String operator;

    KIFOperator(AST ast) {
        super(ast);
    }

    public final String getOperator() {
        return operator;
    }

    public final void setOperator(String operator) {
        this.operator = operator;
    }

    @Override
    ASTNode clone0(AST ast) {
        KIFOperator newNode = ast.newOperator(operator);
        newNode.setSourceStart ( getSourceStart()  );
        newNode.setSourceLength( getSourceLength() );
        return newNode;
    }

    @Override
    int getNodeType0() {
        return ASTNode.OPERATOR;
    }

    @Override
    public void traverse(ASTVisitor visitor) {
        visitor.visit(this);
    }

    @Override
    boolean subtreeMatch0(ASTMatcher matcher, Object other) {
        return matcher.match(this, other);
    }

    @Override
    public String toString() {
        return operator;
    }

    protected final void copyMembers(KIFOperator node) {
        super.copyMembers(node);
        operator = node.operator;
    }

}
