package org.eclipse.palamedes.kif.core.ast;

public class KIFRelSent extends KIFSent {

    private 	  String 		  constName;
    private final KIFSeq<KIFTerm> terms = new KIFSeq<KIFTerm>();

    protected KIFRelSent(AST ast) {
        super(ast);
    }

    @Override
    public final String getName() {
        return constName;
    }

    public final KIFSeq<KIFTerm> getTerms() {
        return terms;
    }

    public final void setConstName(String constName) {
        this.constName = constName;
    }

    @Override
    ASTNode clone0(AST ast) {
        KIFRelSent newNode = ast.newRelSent(constName, terms.clone0(ast));
        return newNode;
    }

    @Override
    int getNodeType0() {
        return ASTNode.RELSENT;
    }

    @Override
    public void traverse(ASTVisitor visitor) {
        visitor.visit(this);
    }

    @Override
    boolean subtreeMatch0(ASTMatcher matcher, Object other) {
        return matcher.match(this, other);
    }

    @Override
    public String toString() {
        return terms.isEmpty() ? constName :
                                 "(" + constName + " " + terms + ")";
    }

    @Override
    public int getOperandCount() {
        return terms.size();
    }

    @Override
    public KIFSeq<KIFTerm> getOperands() {
        return terms;
    }

    protected final void copyMembers(KIFRelSent node) {
        super.copyMembers(node);
        constName = node.constName;
        terms.addAll(node.terms);
        terms.trimToSize();
    }
}
